﻿
using System;
using Microsoft.Xna.Framework.Graphics;

namespace Silo {

	public class Buffer2D : IDisposable {
		Texture2D texture;
		RenderTarget2D surface;
		public Texture2D Texture {
			get { return texture; }
			set { texture = value; }
		}
		public RenderTarget2D Surface {
			get { return surface; }
			set {
				surface = value;
				RenderTarget2D old = (RenderTarget2D)surface.GraphicsDevice.GetRenderTarget(0);
				surface.GraphicsDevice.SetRenderTarget(0, surface);
				surface.GraphicsDevice.ResolveRenderTarget(0);
				texture = surface.GetTexture();
				surface.GraphicsDevice.SetRenderTarget(0, old);
			}
		}
		public void Resolve() {
			surface.GraphicsDevice.ResolveRenderTarget(0);
			texture = surface.GetTexture();
		}
		public void Dispose() {
			if (texture != null)
				texture.Dispose();
			if (surface != null)
				surface.Dispose();
		}
	}

	public class SwapBuffer2D {
		Buffer2D front = new Buffer2D();
		Buffer2D back = new Buffer2D();
		public Buffer2D Front { get { return front; } }
		public Buffer2D Back { get { return back; } }
		public void Swap() {
			Buffer2D temp = front;
			front = back;
			back = temp;
		}
	}

}
